/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.geometries.gui;

import org.jogamp.java3d.Transform3D;
import org.jogamp.vecmath.Matrix3f;
import org.jogamp.vecmath.Vector3f;
import org.visnow.vn.geometries.objects.SignalingTransform3D;
import org.visnow.vn.geometries.parameters.TransformParams;
import org.visnow.vn.lib.utils.SwingInstancer;
import static org.apache.commons.math3.util.FastMath.*;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class TransformPanel extends javax.swing.JPanel
{

    private TransformParams transformParams = new TransformParams();
    private SignalingTransform3D sigTrans = null;
    private Transform3D trans = null;
    private Matrix3f rotMatrix = new Matrix3f(1, 0, 0, 0, 1, 0, 0, 0, 1);
    private Vector3f transVector = new Vector3f();
    private float scale = 1.f;
    private float xScale = 1.f;
    private float yScale = 1.f;
    private float zScale = 1.f;
    private boolean active = true;

    /**
     * Creates new form TransformPanel
     */
    public TransformPanel()
    {
        initComponents();
        exportTransformButton.setVisible(false); //awaiting further development (norkap)
    }

    public void updateGUI(float[] rotValues, float[] transValues, float[] scaleValues, float scale)
    {
        active = false;
        xRotRoller.setValue(rotValues[0]);
        yRotRoller.setValue(rotValues[1]);
        zRotRoller.setValue(rotValues[2]);
        xTransRoller.setValue(transValues[0]);
        yTransRoller.setValue(transValues[1]);
        zTransRoller.setValue(transValues[2]);
        scaleRoller.setValue(scale);
        xScaleRoller.setValue(scaleValues[0]);
        yScaleRoller.setValue(scaleValues[1]);
        zScaleRoller.setValue(scaleValues[2]);
        active = true;
        makeRotMatrix();
    }
    
    public double[] getTransformMatrix() {
        double[] matrix = new double[]{1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1};
        if(trans != null) {
            trans.get(matrix);
        }
        return matrix;
    }
    
    
    public float[] getRotationValues() {
        return new float[] {xRotRoller.getValue(), yRotRoller.getValue(), zRotRoller.getValue()};
    }

    public float[] getTranslationValues() {
        return new float[] {xTransRoller.getValue(), yTransRoller.getValue(), zTransRoller.getValue()};
    }

    public float[] getScaleValues() {
        return new float[] {xScaleRoller.getValue(), yScaleRoller.getValue(), zScaleRoller.getValue()};
    }
    
    public float getScale() {
        return scaleRoller.getValue();
    }
    
    public boolean isAdjusting() {
        return xRotRoller.isAdjusting() || yRotRoller.isAdjusting() || zRotRoller.isAdjusting() ||
            scaleRoller.isAdjusting() || xScaleRoller.isAdjusting() || yScaleRoller.isAdjusting() || zScaleRoller.isAdjusting() ||
            zTransRoller.isAdjusting() || yTransRoller.isAdjusting() || xTransRoller.isAdjusting();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        transformResetButton = new javax.swing.JButton();
        xRotRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        yRotRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        zRotRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        xTransRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        yTransRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        zTransRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        scaleRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        xScaleRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        yScaleRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        zScaleRoller = new org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller();
        exportTransformButton = new javax.swing.JButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setPreferredSize(new java.awt.Dimension(206, 285));
        setLayout(new java.awt.GridBagLayout());

        transformResetButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        transformResetButton.setText("reset/inherit");
        transformResetButton.setMargin(new java.awt.Insets(2, 1, 2, 1));
        transformResetButton.setName("transformResetButton"); // NOI18N
        transformResetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                transformResetButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(4, 0, 4, 0);
        add(transformResetButton, gridBagConstraints);

        xRotRoller.setLabel("rotate yz");
        xRotRoller.setName("xRotRoller"); // NOI18N
        xRotRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xRotRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(xRotRoller, gridBagConstraints);

        yRotRoller.setLabel("rotate xz");
        yRotRoller.setName("yRotRoller"); // NOI18N
        yRotRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yRotRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(yRotRoller, gridBagConstraints);

        zRotRoller.setLabel("rotate xy");
        zRotRoller.setName("zRotRoller"); // NOI18N
        zRotRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                zRotRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(zRotRoller, gridBagConstraints);

        xTransRoller.setLabel("translate x");
        xTransRoller.setName("xTransRoller"); // NOI18N
        xTransRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xTransRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(10, 0, 0, 0);
        add(xTransRoller, gridBagConstraints);

        yTransRoller.setLabel("translate y");
        yTransRoller.setName("yTransRoller"); // NOI18N
        yTransRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yTransRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(yTransRoller, gridBagConstraints);

        zTransRoller.setLabel("translate z");
        zTransRoller.setName("zTransRoller"); // NOI18N
        zTransRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                zTransRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(zTransRoller, gridBagConstraints);

        scaleRoller.setLabel("scale");
        scaleRoller.setName("scaleRoller"); // NOI18N
        scaleRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                scaleRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 0, 3, 0);
        add(scaleRoller, gridBagConstraints);

        xScaleRoller.setLabel("scale x");
        xScaleRoller.setName("xScaleRoller"); // NOI18N
        xScaleRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                xScaleRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(6, 0, 0, 0);
        add(xScaleRoller, gridBagConstraints);

        yScaleRoller.setLabel("scale y");
        yScaleRoller.setName("yScaleRoller"); // NOI18N
        yScaleRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                yScaleRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(yScaleRoller, gridBagConstraints);

        zScaleRoller.setLabel("scale z");
        zScaleRoller.setName("zScaleRoller"); // NOI18N
        zScaleRoller.addChangeListener(new javax.swing.event.ChangeListener()
        {
            public void stateChanged(javax.swing.event.ChangeEvent evt)
            {
                zScaleRollerStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 3, 0);
        add(zScaleRoller, gridBagConstraints);

        exportTransformButton.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        exportTransformButton.setText("export transformation");
        exportTransformButton.setMargin(new java.awt.Insets(2, 1, 2, 1));
        exportTransformButton.setName("exportTransformButton"); // NOI18N
        exportTransformButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                exportTransformButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.weightx = 1.0;
        add(exportTransformButton, gridBagConstraints);

        filler1.setName("filler1"); // NOI18N
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void reset()
    {
        active = false;
        zRotRoller.reset();
        yRotRoller.reset();
        xRotRoller.reset();
        zTransRoller.reset();
        yTransRoller.reset();
        xTransRoller.reset();
        scaleRoller.reset();
        xScaleRoller.reset();
        yScaleRoller.reset();
        zScaleRoller.reset();
        rotMatrix = new Matrix3f(1, 0, 0, 0, 1, 0, 0, 0, 1);
        transVector = new Vector3f();
        scale = xScale = yScale = zScale = 1.f;
        transformParams.resetTransform();
        active = true;
    }

    public void exportButtonVisible(boolean visible)
    {
        exportTransformButton.setVisible(visible);
    }

    private void transformResetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_transformResetButtonActionPerformed
    {//GEN-HEADEREND:event_transformResetButtonActionPerformed
        reset();
    }//GEN-LAST:event_transformResetButtonActionPerformed

    private void scaleRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_scaleRollerStateChanged
    {//GEN-HEADEREND:event_scaleRollerStateChanged
        scale = (float) pow(1.01, scaleRoller.getValue());
        makeRotMatrix();
    }//GEN-LAST:event_scaleRollerStateChanged

    private void xRotRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xRotRollerStateChanged
    {//GEN-HEADEREND:event_xRotRollerStateChanged
        makeRotMatrix();
    }//GEN-LAST:event_xRotRollerStateChanged

    private void yRotRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yRotRollerStateChanged
    {//GEN-HEADEREND:event_yRotRollerStateChanged
        makeRotMatrix();
    }//GEN-LAST:event_yRotRollerStateChanged

    private void zRotRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_zRotRollerStateChanged
    {//GEN-HEADEREND:event_zRotRollerStateChanged
        makeRotMatrix();
    }//GEN-LAST:event_zRotRollerStateChanged

    private void xTransRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xTransRollerStateChanged
    {//GEN-HEADEREND:event_xTransRollerStateChanged
        transVector.x = xTransRoller.getValue();
        trans = new Transform3D(rotMatrix, transVector, scale);
        if (!active)
            return;
        makeRotMatrix();
        //       transformParams.setAdjusting(xTransRoller.isAdjusting());
        //       transformParams.setTransform(trans);
        //       if (sigTrans != null)
        //          sigTrans.setTransform(trans);

    }//GEN-LAST:event_xTransRollerStateChanged

    private void yTransRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yTransRollerStateChanged
    {//GEN-HEADEREND:event_yTransRollerStateChanged
        transVector.y = yTransRoller.getValue();
        trans = new Transform3D(rotMatrix, transVector, scale);
        if (!active)
            return;
        makeRotMatrix();
        //       transformParams.setAdjusting(yTransRoller.isAdjusting());
        //       transformParams.setTransform(trans);
        //       if (sigTrans != null)
        //          sigTrans.setTransform(trans);

    }//GEN-LAST:event_yTransRollerStateChanged

    private void zTransRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_zTransRollerStateChanged
    {//GEN-HEADEREND:event_zTransRollerStateChanged
        transVector.z = zTransRoller.getValue();
        trans = new Transform3D(rotMatrix, transVector, scale);
        if (!active)
            return;
        makeRotMatrix();
        //       transformParams.setAdjusting(zTransRoller.isAdjusting());
        //       transformParams.setTransform(trans);
        //       if (sigTrans != null)
        //          sigTrans.setTransform(trans);

    }//GEN-LAST:event_zTransRollerStateChanged

    private void exportTransformButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_exportTransformButtonActionPerformed
    {//GEN-HEADEREND:event_exportTransformButtonActionPerformed
        sigTrans.fireTransformChanged();
    }//GEN-LAST:event_exportTransformButtonActionPerformed

    private void xScaleRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_xScaleRollerStateChanged
    {//GEN-HEADEREND:event_xScaleRollerStateChanged
        xScale = (float) pow(1.01, xScaleRoller.getValue());
        makeRotMatrix();
    }//GEN-LAST:event_xScaleRollerStateChanged

    private void yScaleRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_yScaleRollerStateChanged
    {//GEN-HEADEREND:event_yScaleRollerStateChanged
        yScale = (float) pow(1.01, yScaleRoller.getValue());
        makeRotMatrix();
    }//GEN-LAST:event_yScaleRollerStateChanged

    private void zScaleRollerStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_zScaleRollerStateChanged
    {//GEN-HEADEREND:event_zScaleRollerStateChanged
        zScale = (float) pow(1.01, zScaleRoller.getValue());
        makeRotMatrix();
    }//GEN-LAST:event_zScaleRollerStateChanged

    private void makeRotMatrix()
    {
        transformParams.setAdjusting(xRotRoller.isAdjusting() || yRotRoller.isAdjusting() || zRotRoller.isAdjusting() ||
            scaleRoller.isAdjusting() || xScaleRoller.isAdjusting() || yScaleRoller.isAdjusting() || zScaleRoller.isAdjusting() ||
            zTransRoller.isAdjusting() || yTransRoller.isAdjusting() || xTransRoller.isAdjusting());
        rotMatrix = new Matrix3f(xScale, 0, 0,
                                 0, yScale, 0,
                                 0, 0, zScale);
        double phi = zRotRoller.getValue() * PI / 180;
        double theta = xRotRoller.getValue() * PI / 180;
        double psi = yRotRoller.getValue() * PI / 180;
        double cp = cos(phi);
        double sp = sin(phi);
        double ct = cos(theta);
        double st = sin(theta);
        double cs = cos(psi);
        double ss = sin(psi);
        Matrix3f tmp = new Matrix3f(
            (float) (cp * cs), (float) (-sp * ct - cp * ss * st), (float) (sp * st - cp * ss * ct),
            (float) (sp * cs), (float) (cp * ct - sp * ss * st), (float) (-cp * st - sp * ss * ct),
            (float) (ss), (float) (cs * st), (float) (cs * ct));
        tmp.mul(rotMatrix);
        trans = new Transform3D(tmp, transVector, scale);
        if (!active)
            return;
        double[] matrix = new double[16];
        trans.get(matrix);
        transformParams.setTransform(matrix);
        if (sigTrans != null)
            sigTrans.setTransform(trans);
    }

    public void setTransformParams(TransformParams transformParams)
    {
        this.transformParams = transformParams;
    }

    public void setSigTrans(SignalingTransform3D sigTrans)
    {
        this.sigTrans = sigTrans;
    }

    public void resetTransform()
    {
        SwingInstancer.swingRunAndWait(new Runnable()
        {
            public void run()
            {
                reset();
            }
        });
    }

    public void setTransSensitivity(float s)
    {
        xTransRoller.setSensitivity(s);
        yTransRoller.setSensitivity(s);
        zTransRoller.setSensitivity(s);
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected javax.swing.JButton exportTransformButton;
    protected javax.swing.Box.Filler filler1;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller scaleRoller;
    protected javax.swing.JButton transformResetButton;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller xRotRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller xScaleRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller xTransRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller yRotRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller yScaleRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller yTransRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller zRotRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller zScaleRoller;
    protected org.visnow.vn.gui.widgets.UnboundedRoller.ExtendedUnboundedRoller zTransRoller;
    // End of variables declaration//GEN-END:variables
}
